//
//  AppDelegate.m
//  e93
//
//  Created by Fred Allen on 11/27/16.
//  Copyright © 2016 Fred Allen. All rights reserved.
//

#include "includes.h"
#import "AppDelegate.h"

static bool mainStarted = false;

@interface AppDelegate()
@end

@implementation AppDelegate

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	NSDictionary *appDefaults = [NSDictionary dictionaryWithObject:@"YES" forKey: @"AppleShowAllFiles"];		// force openDialog to show all files
	[defaults registerDefaults:appDefaults];

	NSArray *args = [[NSProcessInfo processInfo] arguments];
	
	int argc = (int)[args count];
	const char **argv = (const char **) malloc(sizeof(const char*) * argc);
	for (int i = 0; i < argc; i++)
	{
		argv[i] = [[args objectAtIndex:i] UTF8String];
	}
	mainStarted = true;
	InitMain(argc, argv);
	free(argv);
}

- (void)applicationWillTerminate:(NSNotification *)aNotification
{
	UninitMain();
}

- (BOOL)application:(NSApplication *)sender openFile:(NSString *)filename
{
	if (mainStarted)
	{
		char **theList;
		UINT32 numElements = 0;
		theList = NewStringList();
		const char* fullPath = [filename UTF8String];
		AddStringToList(fullPath, &theList, &numElements);											// add that to our list

		if (numElements)
		{
			HandleShellCommand("open", (int)numElements, (const char**)theList);					// tell Tcl script to open these files
		}
		FreeStringList(theList);
		return YES;
	}
	return NO;
}

-(void)application:(NSApplication *)sender openFiles:(NSArray *)filenames
{
	if (mainStarted)																				// don't start handling openFiles until the program inits. Let applicationDidFinishLaunching handle files passed in at startup
	{
		char **theList;
		UINT32 numElements = 0;
		theList = NewStringList();
		for (int i = 0; i < [filenames count]; i++)
		{
			const char* fullPath = [filenames[i] UTF8String];
			AddStringToList(fullPath, &theList, &numElements);											// add that to our list
		}
		if (numElements)
		{
			HandleShellCommand("open", (int)numElements, (const char**)theList);															// tell Tcl script to open these files
		}
		FreeStringList(theList);
	}
}
@end
