// Copyright (C) 2009 Fred Allen.
// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".

bool OkDialog(const char* text);
bool OkCancelDialog(const char* text, bool* cancel);
bool YesNoCancelDialog(const char* text, bool* yes, bool* cancel);
bool GetSimpleTextDialog(const char* title, char* enteredText, UINT32 stringBytes, bool* cancel);
bool SearchReplaceDialog(EDITOR_BUFFER* searchBuffer, EDITOR_BUFFER* replaceBuffer, bool* backwards, bool* wrapAround, bool* selectionExpr, bool* ignoreCase, bool* limitScope, bool* replaceProc, UINT16* searchType, bool* cancel);
bool SimpleListBoxDialog(const char* title, UINT32 numElements, const char** listElements, bool* selectedElements, bool* cancel);
bool OpenFileDialog(const char* title, char* fullPath, UINT32 stringBytes, char** *listElements, bool* cancel);
void FreeOpenFileDialogPaths(char** paths);
bool SaveFileDialog(const char* title, char* fullPath, UINT32 stringBytes, bool* cancel);
bool ChoosePathDialog(const char* title, char* fullPath, UINT32 stringBytes, bool* cancel);
bool ChooseFontDialog(const char* title, char* font, UINT32 stringBytes, bool* cancel);

@interface SimpleTextWindow : NSWindow
	@property (weak) IBOutlet NSTextField* textEdit;
@end

@interface FindReplaceWindow : NSWindow
	@property (weak) IBOutlet NSTextField* findTextEdit;
@property (weak) IBOutlet NSTextField* replaceTextEdit;
@property (weak) IBOutlet NSButton* searchBackwardCheckBox;
@property (weak) IBOutlet NSButton* limitScopeCheckBox;
@property (weak) IBOutlet NSButton* treatReplaceTextCheckBox;
@property (weak) IBOutlet NSButton* selectionExpressionCheckBox;
@property (weak) IBOutlet NSButton* ignoreCaseCheckBox;
@property (weak) IBOutlet NSButton* wrapAroundCheckBox;
@end


@interface SimpleListBoxWindow : NSWindow
	@property (weak) IBOutlet NSTableView* tableView;
@property (nonatomic, assign) UINT32 numElements;
@property (nonatomic, assign) const char** listElements;
@end

@interface ChooseFontWindow : NSWindow
	@property (weak) IBOutlet NSComboBox* familyPopupBox;
@property (weak) IBOutlet NSComboBox* typefacePopupBox;
@property (weak) IBOutlet NSComboBox* sizePopupBox;
@property (weak) IBOutlet NSTextField* fontDisplayLabel;
@property (nonatomic, assign) EDITOR_FONT* theFont;
@property (nonatomic, strong) NSArray* familyFaces;
@property (nonatomic, assign) BOOL initializing;
@end

