// Copyright (C) 2009 Fred Allen.
// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".


void LinkWindowElement(WINDOWLISTELEMENT* theElement);
void UnlinkWindowElement(WINDOWLISTELEMENT* theElement);
void InvalidateAllBottomBars();
WINDOWLISTELEMENT* LocateEditorWindow(void* window);
WINDOWLISTELEMENT* LocateActiveEditorWindow();
void ReAdjustDocumentColors(EDITOR_WINDOW* theWindow);
void AdjustDocumentWindowStatus(EDITOR_WINDOW* theWindow);
void AdjustDocumentWindowViewStatus(EDITOR_VIEW* theView);
void AdjustDocumentWindowScrollThumbs(EDITOR_VIEW* theView);
void ScrollEditViewEvent(EDITOR_VIEW* theView, UINT32 eventCode, bool repeating);
void ScrollEditViewThumbVerticalEvent(EDITOR_VIEW* theView, UINT32 newValue);
void ScrollEditViewThumbHorizontalEvent(EDITOR_VIEW* theView, UINT32 newValue);
void UpdateEditorWindows();
void SetTopDocumentWindow(EDITOR_WINDOW* theWindow);
EDITOR_WINDOW* GetActiveDocumentWindow();
EDITOR_WINDOW* GetTopDocumentWindow();
EDITOR_WINDOW* GetNextDocumentWindow(EDITOR_WINDOW* previousWindow);
bool GetDocumentWindowTitle(EDITOR_WINDOW* theWindow, char* theTitle, UINT32 stringBytes);
bool SetDocumentWindowTitle(EDITOR_WINDOW* theWindow, char* theTitle);
bool GetSortedDocumentWindowList(UINT32* numElements, EDITOR_WINDOW** *theList);
bool GetEditorDocumentWindowForegroundColor(EDITOR_WINDOW* theWindow, EDITOR_COLOR* foregroundColor);
bool SetEditorDocumentWindowForegroundColor(EDITOR_WINDOW* theWindow, EDITOR_COLOR foregroundColor);
bool GetEditorDocumentWindowBackgroundColor(EDITOR_WINDOW* theWindow, EDITOR_COLOR* backgroundColor);
bool SetEditorDocumentWindowBackgroundColor(EDITOR_WINDOW* theWindow, EDITOR_COLOR backgroundColor);
bool GetEditorDocumentWindowRect(EDITOR_WINDOW* theWindow, EDITOR_RECT* theRect);
bool SetEditorDocumentWindowRect(EDITOR_WINDOW* theWindow, EDITOR_RECT* theRect);
void GetEditorScreenDimensions(UINT32* theWidth, UINT32* theHeight);
void CloseDocumentWindow(EDITOR_WINDOW* theWindow);

void MaximizeDocumentWindow(EDITOR_WINDOW* theWindow);
void RestoreDocumentWindow(EDITOR_WINDOW* theWindow);
