// Copyright (C) 2009 Fred Allen.
// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".


typedef struct editorFont
{
	UINT32 usageCount;							// tells how many references there are to this font
	char name[256];								// name of this font
	UINT16 charWidths[256];						// cache of widths of all the characters in the font
	char postScriptName[256];					// post script name of the font
	UINT32 ascent;
	UINT32 descent;
	UINT32 leading;
	UINT32 size;
	char family[64];
	char weight[32];
	char slant[32];
	INT32 maxCharWidth;
	INT32 maxLeftOverhang;						// gives maximum overhang of any characeter in this font to the left of its origin
	INT32 maxRightOverhang;						// gives maximum overhang of any characeter in this font to the right of its width
	struct editorFont* next;					// used to link the fonts to the global list
	struct editorFont* previous;
	uint32_t traits;
	NSFont* fontRef;
} EDITOR_FONT;


